var $$ = {
  cookie: function(name, value, expires_days) {
    if(value != '' && expires_days != '') {
      var d = new Date();
      d.setTime(d.getTime() + (expires_days*24*60*60*1000));
      var expires = "expires="+d.toUTCString();
      document.cookie = name + "=" + value + "; " + expires;
    }
    else
    {
      var cname = name + "=";
      var ca = document.cookie.split(';');
      for(var i=0; i<ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1);
          if (c.indexOf(name) == 0) return c.substring(cname.length,c.length);
    }
    return "";    
    }
  },
  ajax: function(path, method, data, onReadyCallback) {
   var xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
      if(xhttp.readyState == 4 && xhttp.status == 200) {
        onReadyCallback(xhttp.responseText);
      }
    };
    xhttp.open(method, path, true);
    if(data != '' && data != null)
    {
      xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
      xhttp.send(data);
    }
    else
    {
      xhttp.send();
    }
  },
  title: function(title) {
    document.title = title;
  },
  each: function(arr, cb)
  {

  }
};

function $(object)
{
  return new Core(object);
}

function Core(object) 
{
  this.object = object;
}

Core.prototype.text = function(text)
{
  if(text == null)
  {
    return document.getElementById($(this.object).getTypeName()).innerHTML;
  }
  else
  {
    document.getElementById($(this.object).getTypeName()).innerHTML = text;
  }
}

Core.prototype.add = function(text)
{
  $(this.object).text(text);
}

Core.prototype.exist = function()
{
  var el = document.getElementById($(this.object));
  if(el === null)
    return false;
  else
    return true;
}

Core.prototype.append = function(tag, text) 
{
  var node = document.createElement(tag);
  var textnode = document.createTextNode(text);
  node.appendChild(textnode);

  document.getElementById($(this.object).getTypeName()).appendChild(node);
  return node;
}

Core.prototype.appendBefore = function(tag, text) 
{
  var node = document.createElement(tag);
  var textnode = document.createTextNode(text);
  node.appendChild(textnode);
  
  var list = document.getElementById($(this.object).getTypeName());
  list.insertBefore(node, list.childNodes[0]);
  return node;
}


Core.prototype.val = function(text)
{
  if(text == null)
  {
    return document.getElementById($(this.object).getTypeName()).value;
  }
  else
  {
    document.getElementById($(this.object).getTypeName()).value = text;
  }
}

Core.prototype.css = function(value)
{
  if(value == null)
  {
      return document.getElementById($(this.object).getTypeName()).getAttribute('style');
  }
  else
  {
    document.getElementById($(this.object).getTypeName()).setAttribute('style', value);
  }
}

Core.prototype.hide = function()
{
  $(this.object).css('visibility:hide;');
}

Core.prototype.show = function()
{
  $(this.object).css('visibility:visible;');
}

Core.prototype.height = function() 
{
  var element = document.getElementById($(this.object).getTypeName());
  var positionInfo = element.getBoundingClientRect();
  var height;
  height = positionInfo.height;
  if(height == null) 
    height = element.offsetHeight;

  return height;
}

Core.prototype.width = function() 
{
  var element = document.getElementById($(this.object).getTypeName());
  var positionInfo = element.getBoundingClientRect();
  var width;
  width = positionInfo.width;
  if(width == null) 
    width = element.offsetWidth;
  return width;
}

Core.prototype.attr = function(attribute, val)
{
  var element = document.getElementById($(this.object).getTypeName());
  if(val == null)
  {
    return element.getAttribute(val);
  }
  else
  {
    element.setAttribute(attribute, val);
  }
}

Core.prototype.length = function()
{
  try {
    var element = document.getElementById($(this.object).getTypeName());
    return element.innerHTML.length();
  }
  catch(err) { return 0; } 
}

Core.prototype.each = function(arr, cb)
{

}

Core.prototype.element = function()
{
  return document.getElementById($(this.object));
}

Core.prototype.getType = function()
{
  return this.object.charAt(0);
}

Core.prototype.getTypeName = function()
{
  return this.object;
}

